
import java.io.*;
import java.math.*;
import java.util.*;
import static java.lang.Math.*;

public class Timus_1575 implements Runnable {
	
	StreamTokenizer tok;
	BufferedReader in;
	PrintWriter out;
	boolean timus = System.getProperty("ONLINE_JUDGE") != null;
	
	void init() throws IOException {
		if (timus) {
			in = new BufferedReader(new InputStreamReader(System.in));
			tok = new StreamTokenizer(in);
			out = new PrintWriter(System.out);
		} else {
			in = new BufferedReader(new FileReader("input.txt"));
			tok = new StreamTokenizer(in);
			out = new PrintWriter("output.txt");
		}
	}
	
	int readInt() throws IOException {
		tok.nextToken();
		return (int) tok.nval;
	}
	
	String readString() throws IOException {
		tok.nextToken();
		return tok.sval;
	}
	
	public static void main(String[] args) {
		new Thread(new Timus_1575()).start();
	}
	
	@Override
	public void run() {
		try {
			if (timus) {
				init();
				solve();
				out.flush();
			} else {
				long t1 = System.currentTimeMillis();
				init();
				solve();
				out.close();
				long t2 = System.currentTimeMillis();
				System.out.println(t2 - t1);
			}
		} catch(IOException e) {
			System.exit(1);
		}
	}
	
	final String _7_klyuchey = "7_klyuchey";
	final String _Sortirovochnaya = "Sortirovochnaya";
	final String _China_town = "China_town";
	final String _Zarechny = "Zarechny";
	final String _Pobedy = "Pobedy";
	final String _I_Pyatiletki_square = "I_Pyatiletki_square";
	final String _Zvezda = "Zvezda";
	final String _Bakinskih_Komissarov = "Bakinskih_Komissarov";
	final String _Prospekt_Kosmonavtov = "Prospekt_Kosmonavtov";
	final String _Uralmash = "Uralmash";
	
	final String _Mashinostroiteley = "Mashinostroiteley";
	final String _Taganskaya = "Taganskaya";
	final String _Elmash = "Elmash";
	final String _Turbinnaya = "Turbinnaya";
	final String _Vilonovskaya = "Vilonovskaya";
	final String _Kalinovskaya = "Kalinovskaya";
	final String _Italyanskaya = "Italyanskaya";
	final String _Ozyornaya = "Ozyornaya";
	final String _Shefskaya = "Shefskaya";
	final String _Komsomolskaya = "Komsomolskaya";
	
	final String _Kamennye_palatki = "Kamennye_palatki";
	final String _University = "University";
	final String _Siniye_kamni = "Siniye_kamni";
	final String _Lechebnaya = "Lechebnaya";
	final String _Varshavskaya = "Varshavskaya";
	final String _Kompressornaya = "Kompressornaya";
	final String _Koltsovo = "Koltsovo";
	final String _Mayakovskaya = "Mayakovskaya";
	final String _Parkovaya = "Parkovaya";
	final String _Botanicheskaya = "Botanicheskaya";
	
	final String _Samolyotnaya = "Samolyotnaya";
	final String _Vtorchermet = "Vtorchermet";
	final String _Keramicheskaya = "Keramicheskaya";
	final String _Chkalovskaya = "Chkalovskaya";
	final String _Shcherbakovskaya = "Shcherbakovskaya";
	final String _Uktusskie_Gory = "Uktusskie_Gory";
	final String _Nizhne_Isetskaya = "Nizhne_Isetskaya";
	final String _Himmash = "Himmash";
	final String _Aviatsionnaya = "Aviatsionnaya";
	final String _Voennaya = "Voennaya";
	
	final String _Sovhoznaya = "Sovhoznaya";
	final String _Volgogradskaya = "Volgogradskaya";
	final String _Yugo_zapadnaya = "Yugo_zapadnaya";
	final String _Akademicheskaya = "Akademicheskaya";
	final String _Central_stadium = "Central_stadium";
	final String _Kraulya = "Kraulya";
	final String _Metallurgov = "Metallurgov";
	final String _MEGA = "MEGA";
	final String _Verh_Isetskaya = "Verh_Isetskaya";
	final String _Tatishchevskaya = "Tatishchevskaya";
	
	final String _Zelyony_ostrov = "Zelyony_ostrov";
	final String _City = "City";
	final String _Uralskaya = "Uralskaya";
	final String _Pionerskaya = "Pionerskaya";
	final String _Gagarinskaya = "Gagarinskaya";
	final String _Vtuzgorodok = "Vtuzgorodok";
	final String _Sibirskaya = "Sibirskaya";
	final String _Oborony_square = "Oborony_square";
	final String _Bazhovskaya = "Bazhovskaya";
	final String _Dvorets_sporta = "Dvorets_sporta";
	
	final String _Posadskaya = "Posadskaya";
	final String _Moskovskaya = "Moskovskaya";
	final String _Kommunarov_square = "Kommunarov_square";
	final String _Dinamo = "Dinamo";
	final String _Shevchenko = "Shevchenko";
	final String _1905_year_square = "1905_year_square";
	final String _Teatralnaya = "Teatralnaya";
	final String _Vostochnaya = "Vostochnaya";
	final String _Geologicheskaya = "Geologicheskaya";
	final String _Kuybyshevskaya = "Kuybyshevskaya";
	
	HashMap<String, Integer> names = new HashMap<String, Integer>();
	
	void initNames() {
		names.put(_7_klyuchey, 0);
		names.put(_Sortirovochnaya, 1);
		names.put(_China_town, 2);
		names.put(_Zarechny, 3);
		names.put(_Pobedy, 4);
		names.put(_I_Pyatiletki_square, 5);
		names.put(_Zvezda, 6);
		names.put(_Bakinskih_Komissarov, 7);
		names.put(_Prospekt_Kosmonavtov, 8);
		names.put(_Uralmash, 9);
		
		names.put(_Mashinostroiteley, 10);
		names.put(_Taganskaya, 11);
		names.put(_Elmash, 12);
		names.put(_Turbinnaya, 13);
		names.put(_Vilonovskaya, 14);
		names.put(_Kalinovskaya, 15);
		names.put(_Italyanskaya, 16);
		names.put(_Ozyornaya, 17);
		names.put(_Shefskaya, 18);
		names.put(_Komsomolskaya, 19);
		
		names.put(_Kamennye_palatki, 20);
		names.put(_University, 21);
		names.put(_Siniye_kamni, 22);
		names.put(_Lechebnaya, 23);
		names.put(_Varshavskaya, 24);
		names.put(_Kompressornaya, 25);
		names.put(_Koltsovo, 26);
		names.put(_Mayakovskaya, 27);
		names.put(_Parkovaya, 28);
		names.put(_Botanicheskaya, 29);

		names.put(_Samolyotnaya, 30);
		names.put(_Vtorchermet, 31);
		names.put(_Keramicheskaya, 32);
		names.put(_Chkalovskaya, 33);
		names.put(_Shcherbakovskaya, 34);
		names.put(_Uktusskie_Gory, 35);
		names.put(_Nizhne_Isetskaya, 36);
		names.put(_Himmash, 37);
		names.put(_Aviatsionnaya, 38);
		names.put(_Voennaya, 39);
		
		names.put(_Sovhoznaya, 40);
		names.put(_Volgogradskaya, 41);
		names.put(_Yugo_zapadnaya, 42);
		names.put(_Akademicheskaya, 43);
		names.put(_Central_stadium, 44);
		names.put(_Kraulya, 45);
		names.put(_Metallurgov, 46);
		names.put(_MEGA, 47);
		names.put(_Verh_Isetskaya, 48);
		names.put(_Tatishchevskaya, 49);
		
		names.put(_Zelyony_ostrov, 50);
		names.put(_City, 51);
		names.put(_Uralskaya, 52);
		names.put(_Pionerskaya, 53);
		names.put(_Gagarinskaya, 54);
		names.put(_Vtuzgorodok, 55);
		names.put(_Sibirskaya, 56);
		names.put(_Oborony_square, 57);
		names.put(_Bazhovskaya, 58);
		names.put(_Dvorets_sporta, 59);
		
		names.put(_Posadskaya, 60);
		names.put(_Moskovskaya, 61);
		names.put(_Kommunarov_square, 62);
		names.put(_Dinamo, 63);
		names.put(_Shevchenko, 64);
		names.put(_1905_year_square, 65);
		names.put(_Teatralnaya, 66);
		names.put(_Vostochnaya, 67);
		names.put(_Geologicheskaya, 68);
		names.put(_Kuybyshevskaya, 69);
	}
	
	final int n = 70;
	final int INF = 1000 * 1000 * 1000;
	int[][] graph = new int[n][n];
	
	void makeEdge(String fromName, String toName) {
		int from = names.get(fromName);
		int to = names.get(toName);
		graph[from][to] = 1;
		graph[to][from] = 1;
	}
	
	void initGraphEdges() {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				graph[i][j] = (i == j) ? 0 : INF;
			}
		}
		makeEdge(_7_klyuchey, _Sortirovochnaya);
		makeEdge(_Sortirovochnaya, _China_town);
		makeEdge(_China_town, _Zarechny);
		makeEdge(_Zarechny, _City);
		makeEdge(_City, _1905_year_square);
		makeEdge(_1905_year_square, _Kuybyshevskaya);
		makeEdge(_Kuybyshevskaya, _Sibirskaya);
		makeEdge(_Sibirskaya, _Siniye_kamni);
		makeEdge(_Siniye_kamni, _Lechebnaya);
		makeEdge(_Lechebnaya, _Varshavskaya);
		makeEdge(_Varshavskaya, _Kompressornaya);
		makeEdge(_Kompressornaya, _Koltsovo);
		
		makeEdge(_Pobedy, _I_Pyatiletki_square);
		makeEdge(_I_Pyatiletki_square, _Zvezda);
		makeEdge(_Zvezda, _Uralskaya);
		makeEdge(_Uralskaya, _Shevchenko);
		makeEdge(_Shevchenko, _Teatralnaya);
		makeEdge(_Teatralnaya, _Kuybyshevskaya);
		makeEdge(_Kuybyshevskaya, _Oborony_square);
		makeEdge(_Oborony_square, _Mayakovskaya);
		makeEdge(_Mayakovskaya, _Parkovaya);
		makeEdge(_Parkovaya, _Botanicheskaya);
		makeEdge(_Botanicheskaya, _Samolyotnaya);
		makeEdge(_Samolyotnaya, _Vtorchermet);
		makeEdge(_Vtorchermet, _Keramicheskaya);
		
		makeEdge(_Bakinskih_Komissarov, _Prospekt_Kosmonavtov);
		makeEdge(_Prospekt_Kosmonavtov, _Uralmash);
		makeEdge(_Uralmash, _Mashinostroiteley);
		makeEdge(_Mashinostroiteley, _Uralskaya);
		makeEdge(_Uralskaya, _Dinamo);
		makeEdge(_Dinamo, _1905_year_square);
		makeEdge(_1905_year_square, _Geologicheskaya);
		makeEdge(_Geologicheskaya, _Bazhovskaya);
		makeEdge(_Bazhovskaya, _Chkalovskaya);
		makeEdge(_Chkalovskaya, _Botanicheskaya);
		makeEdge(_Botanicheskaya, _Shcherbakovskaya);
		makeEdge(_Shcherbakovskaya, _Uktusskie_Gory);
		makeEdge(_Uktusskie_Gory, _Nizhne_Isetskaya);
		makeEdge(_Nizhne_Isetskaya, _Himmash);
		
		makeEdge(_Taganskaya, _Elmash);
		makeEdge(_Elmash, _Turbinnaya);
		makeEdge(_Turbinnaya, _Pionerskaya);
		makeEdge(_Pionerskaya, _Shevchenko);
		makeEdge(_Shevchenko, _1905_year_square);
		makeEdge(_1905_year_square, _Moskovskaya);
		makeEdge(_Moskovskaya, _Central_stadium);
		makeEdge(_Central_stadium, _Kraulya);
		makeEdge(_Kraulya, _Metallurgov);
		makeEdge(_Metallurgov, _MEGA);
		
		makeEdge(_Vilonovskaya, _Gagarinskaya);
		makeEdge(_Gagarinskaya, _Vostochnaya);
		makeEdge(_Vostochnaya, _Kuybyshevskaya);
		makeEdge(_Kuybyshevskaya, _Geologicheskaya);
		makeEdge(_Geologicheskaya, _Dvorets_sporta);
		makeEdge(_Dvorets_sporta, _Aviatsionnaya);
		makeEdge(_Aviatsionnaya, _Voennaya);
		makeEdge(_Voennaya, _Sovhoznaya);
		
		makeEdge(_Kalinovskaya, _Italyanskaya);
		makeEdge(_Italyanskaya, _Ozyornaya);
		makeEdge(_Ozyornaya, _Shefskaya);
		makeEdge(_Shefskaya, _Komsomolskaya);
		makeEdge(_Komsomolskaya, _Gagarinskaya);
		makeEdge(_Gagarinskaya, _Teatralnaya);
		makeEdge(_Teatralnaya, _Geologicheskaya);
		makeEdge(_Geologicheskaya, _Posadskaya);
		makeEdge(_Posadskaya, _Volgogradskaya);
		makeEdge(_Volgogradskaya, _Yugo_zapadnaya);
		makeEdge(_Yugo_zapadnaya, _Akademicheskaya);
		
		makeEdge(_University, _Kamennye_palatki);
		makeEdge(_Kamennye_palatki, _Vtuzgorodok);
		makeEdge(_Vtuzgorodok, _Vostochnaya);
		makeEdge(_Vostochnaya, _Teatralnaya);
		makeEdge(_Teatralnaya, _1905_year_square);
		makeEdge(_1905_year_square, _Kommunarov_square);
		makeEdge(_Kommunarov_square, _Verh_Isetskaya);
		makeEdge(_Verh_Isetskaya, _Tatishchevskaya);
		makeEdge(_Tatishchevskaya, _Zelyony_ostrov);
		
		makeEdge(_City, _Uralskaya);
		makeEdge(_Uralskaya, _Pionerskaya);
		makeEdge(_Pionerskaya, _Gagarinskaya);
		makeEdge(_Gagarinskaya, _Vtuzgorodok);
		makeEdge(_Vtuzgorodok, _Sibirskaya);
		makeEdge(_Sibirskaya, _Oborony_square);
		makeEdge(_Oborony_square, _Bazhovskaya);
		makeEdge(_Bazhovskaya, _Dvorets_sporta);
		makeEdge(_Dvorets_sporta, _Posadskaya);
		makeEdge(_Posadskaya, _Moskovskaya);
		makeEdge(_Moskovskaya, _Kommunarov_square);
		makeEdge(_Kommunarov_square, _City);
	}
	
	void calculateDistances() {
		for (int k = 0; k < n; k++) {
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					graph[i][j] = min(graph[i][j], graph[i][k] + graph[k][j]);
				}
			}
		}
	}
	
	void solve() throws IOException {
		initNames();
		initGraphEdges();
		calculateDistances();
		int tests = Integer.parseInt(in.readLine());
		String[] s;
		for (int i = 0; i < tests; i++) {
			s = in.readLine().split(" ");
			int from = names.get(s[0]);
			int to = names.get(s[1]);
			out.println(graph[from][to]);
		}
	}
	
}
