
import java.io.*;
import java.math.*;
import java.util.*;

import javax.swing.plaf.basic.BasicScrollPaneUI.HSBChangeListener;

import static java.lang.Math.*;

public class Timus_1654 implements Runnable {
	
	StreamTokenizer tok;
	BufferedReader in;
	PrintWriter out;
	boolean timus = System.getProperty("ONLINE_JUDGE") != null;
	
	void init() throws IOException {
		if (timus) {
			in = new BufferedReader(new InputStreamReader(System.in));
			tok = new StreamTokenizer(in);
			out = new PrintWriter(System.out);
		} else {
			in = new BufferedReader(new FileReader("input.txt"));
			tok = new StreamTokenizer(in);
			out = new PrintWriter("output.txt");
		}
	}
	
	int readInt() throws IOException {
		tok.nextToken();
		return (int) tok.nval;
	}
	
	String readString() throws IOException {
		tok.nextToken();
		return tok.sval;
	}
	
	public static void main(String[] args) {
		new Thread(new Timus_1654()).start();
	}
	
	@Override
	public void run() {
		try {
			if (timus) {
				init();
				solve();
				out.flush();
			} else {
				long t1 = System.currentTimeMillis();
				init();
				solve();
				out.close();
				long t2 = System.currentTimeMillis();
				System.out.println(t2 - t1);
			}
		} catch(IOException e) {
			System.exit(1);
		}
	}
	
	void solve() throws IOException {
		LinkedList<Character> list = new LinkedList<Character>();
		int c = in.read();
		while (c != -1) {
			list.add((char) c);
			c = in.read();
		}
		ListIterator<Character> it = list.listIterator();
		while (it.hasNext()) {
			char c1 = it.next();
			if (!it.hasNext()) break;
			char c2 = it.next();
			if (c1 == c2) {
				it.remove();
				it.previous();
				it.remove();
			}
			if (it.hasPrevious()) it.previous();
		}
		it = list.listIterator();
		while (it.hasNext()) {
			out.print(it.next());
		}
	}
	
}
