
import java.io.*;
import java.math.*;
import java.util.*;
import static java.lang.Math.*;

public class Timus_1785 implements Runnable {

	StreamTokenizer tok;
	BufferedReader in;
	PrintWriter out;
	boolean timus = System.getProperty("ONLINE_JUDGE") != null;

	void init() throws IOException {
		if (timus) {
			in = new BufferedReader(new InputStreamReader(System.in));
			tok = new StreamTokenizer(in);
			out = new PrintWriter(System.out);
		} else {
			in = new BufferedReader(new FileReader("input.txt"));
			tok = new StreamTokenizer(in);
			out = new PrintWriter("output.txt");
		}
	}

	int readInt() throws IOException {
		tok.nextToken();
		return (int) tok.nval;
	}

	String readString() throws IOException {
		tok.nextToken();
		return tok.sval;
	}

	public static void main(String[] args) {
		new Thread(new Timus_1785()).start();
	}

	@Override
	public void run() {
		try {
			if (timus) {
				init();
				solve();
				out.flush();
			} else {
				long t1 = System.currentTimeMillis();
				init();
				solve();
				out.close();
				long t2 = System.currentTimeMillis();
				System.out.println(t2 - t1);
			}
		} catch(IOException e) {
			System.exit(1);
		}
	}

	void solve() throws IOException {
		int n = readInt();
		String ans = null;
		if (n <= 4) ans = "few";
		else if (n <= 9) ans = "several";
		else if (n <= 19) ans = "pack";
		else if (n <= 49) ans = "lots";
		else if (n <= 99) ans = "horde";
		else if (n <= 249) ans = "throng";
		else if (n <= 499) ans = "swarm";
		else if (n <= 999) ans = "zounds";
		else ans = "legion";
		out.println(ans);
	}

}
