
import java.io.*;
import java.math.*;
import java.util.*;
import static java.lang.Math.*;

public class Timus_1197 implements Runnable {
	
	StreamTokenizer tok;
	BufferedReader in;
	PrintWriter out;
	boolean timus = System.getProperty("ONLINE_JUDGE") != null;
	
	void init() throws IOException {
		if (timus) {
			in = new BufferedReader(new InputStreamReader(System.in));
			tok = new StreamTokenizer(in);
			out = new PrintWriter(System.out);
		} else {
			in = new BufferedReader(new FileReader("input.txt"));
			tok = new StreamTokenizer(in);
			out = new PrintWriter("output.txt");
		}
	}
	
	int readInt() throws IOException {
		tok.nextToken();
		return (int) tok.nval;
	}
	
	String readString() throws IOException {
		tok.nextToken();
		return tok.sval;
	}
	
	public static void main(String[] args) {
		new Thread(new Timus_1197()).start();
	}
	
	@Override
	public void run() {
		try {
			if (timus) {
				init();
				solve();
				out.flush();
			} else {
				long t1 = System.currentTimeMillis();
				init();
				solve();
				out.close();
				long t2 = System.currentTimeMillis();
				System.out.println(t2 - t1);
			}
		} catch(IOException e) {
			System.exit(1);
		}
	}
	
	void solve() throws IOException {
		int n = Integer.parseInt(in.readLine());
		for (int i = 0; i < n; i++) {
			String s = in.readLine();
			int [] a = new int[2];
			a[0] = s.charAt(0) - 'a' + 1;
			a[1] = s.charAt(1) - '1' + 1;
			a[0] = min(a[0], 9 - a[0]);
			a[1] = min(a[1], 9 - a[1]);
			Arrays.sort(a);
			
			if (a[0] == 1 && a[1] == 1) out.println(2);
			else if (a[0] == 1 && a[1] == 2) out.println(3);
			else if (a[0] == 1 || (a[0] == 2 && a[1] == 2)) out.println(4);
			else if (a[0] == 2) out.println(6);
			else out.println(8);
		}
	}
	
}
