
import java.io.*;
import java.math.*;
import java.util.*;
import static java.lang.Math.*;

public class Timus_1295 implements Runnable {
	
	StreamTokenizer tok;
	BufferedReader in;
	PrintWriter out;
	boolean timus = System.getProperty("ONLINE_JUDGE") != null;
	
	void init() throws IOException {
		if (timus) {
			in = new BufferedReader(new InputStreamReader(System.in));
			tok = new StreamTokenizer(in);
			out = new PrintWriter(System.out);
		} else {
			in = new BufferedReader(new FileReader("input.txt"));
			tok = new StreamTokenizer(in);
			out = new PrintWriter("output.txt");
		}
	}
	
	int readInt() throws IOException {
		tok.nextToken();
		return (int) tok.nval;
	}
	
	String readString() throws IOException {
		tok.nextToken();
		return tok.sval;
	}
	
	public static void main(String[] args) {
		new Thread(new Timus_1295()).start();
	}
	
	@Override
	public void run() {
		try {
			if (timus) {
				init();
				solve();
				out.flush();
			} else {
				long t1 = System.currentTimeMillis();
				init();
				solve();
				out.close();
				long t2 = System.currentTimeMillis();
				System.out.println(t2 - t1);
			}
		} catch(IOException e) {
			System.exit(1);
		}
	}
	
	void solve() throws IOException {
		int n = readInt();
		int ans = 0;
		switch (n % 20) {
			case 1:  ans = 1; break;
			case 2:  ans = 1; break;
			case 3:  ans = 2; break;
			case 4:  ans = 0; break;
			case 5:  ans = 2; break;
			case 6:  ans = 1; break;
			case 7:  ans = 2; break;
			case 8:  ans = 0; break;
			case 9:  ans = 1; break;
			case 10: ans = 1; break;
			case 11: ans = 2; break;
			case 12: ans = 0; break;
			case 13: ans = 1; break;
			case 14: ans = 1; break;
			case 15: ans = 2; break;
			case 16: ans = 0; break;
			case 17: ans = 1; break;
			case 18: ans = 1; break;
			case 19: ans = 2; break;
			case 0:  ans = 0; break;
		}
		out.println(ans);
	}
	
}
