
import java.io.*;
import java.math.*;
import java.util.*;
import static java.lang.Math.*;

public class Timus_1506 implements Runnable {
	
	StreamTokenizer tok;
	BufferedReader in;
	PrintWriter out;
	boolean timus = System.getProperty("ONLINE_JUDGE") != null;
	
	void init() throws IOException {
		if (timus) {
			in = new BufferedReader(new InputStreamReader(System.in));
			tok = new StreamTokenizer(in);
			out = new PrintWriter(System.out);
		} else {
			in = new BufferedReader(new FileReader("input.txt"));
			tok = new StreamTokenizer(in);
			out = new PrintWriter("output.txt");
		}
	}
	
	int readInt() throws IOException {
		tok.nextToken();
		return (int) tok.nval;
	}
	
	String readString() throws IOException {
		tok.nextToken();
		return tok.sval;
	}
	
	public static void main(String[] args) {
		new Thread(new Timus_1506()).start();
	}
	
	@Override
	public void run() {
		try {
			if (timus) {
				init();
				solve();
				out.flush();
			} else {
				long t1 = System.currentTimeMillis();
				init();
				solve();
				out.close();
				long t2 = System.currentTimeMillis();
				System.out.println(t2 - t1);
			}
		} catch(IOException e) {
			System.exit(1);
		}
	}
	
	void solve() throws IOException {
		int n = readInt();
		int k = readInt();
		int[] a = new int[n];
		for (int i = 0; i < n; i++) {
			a[i] = readInt();
		}
		int m;
		if (n % k == 0)
			m = n / k;
		else
			m = n / k + 1;
		int[][] b = new int[m][k];
		int p = 0;
zzz:	for (int j = 0; j < k - 1; j++) {
			for (int i = 0; i < m; i++) {
				if (p >= m * (k - 1)) break zzz;
				b[i][j] = a[p++];
			}
		}
		for (int i = 0; i < m; i++) {
			if (p >= n) {
				b[i][k - 1] = -1;
			}
			else {
				b[i][k - 1] = a[p++];
			}
		}
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < k; j++) {
				if (b[i][j] != -1) {
					print(b[i][j]);
				}
			}
			out.println();
		}
	}
	
	void print(int a) {
		if (a < 10) { out.print("   " + a); return; }
		if (a < 100) { out.print("  " + a); return; }
		out.print(" " + a);
	}
	
}
