
import java.io.*;
import java.math.*;
import java.util.*;
import static java.lang.Math.*;

public class Timus_1796 implements Runnable {

	StreamTokenizer tok;
	BufferedReader in;
	PrintWriter out;
	boolean timus = System.getProperty("ONLINE_JUDGE") != null;

	void init() throws IOException {
		if (timus) {
			in = new BufferedReader(new InputStreamReader(System.in));
			tok = new StreamTokenizer(in);
			out = new PrintWriter(System.out);
		} else {
			in = new BufferedReader(new FileReader("input.txt"));
			tok = new StreamTokenizer(in);
			out = new PrintWriter("output.txt");
		}
	}

	int readInt() throws IOException {
		tok.nextToken();
		return (int) tok.nval;
	}

	String readString() throws IOException {
		tok.nextToken();
		return tok.sval;
	}

	public static void main(String[] args) {
		new Thread(new Timus_1796()).start();
	}

	@Override
	public void run() {
		try {
			if (timus) {
				init();
				solve();
				out.flush();
			} else {
				long t1 = System.currentTimeMillis();
				init();
				solve();
				out.close();
				long t2 = System.currentTimeMillis();
				System.out.println(t2 - t1);
			}
		} catch(IOException e) {
			System.exit(1);
		}
	}
	
	int[] a = new int[6];
	
	int money() {
		return	a[0] * 10 +	  a[1] * 50 +
				a[2] * 100 +  a[3] * 500 +
				a[4] * 1000 + a[5] * 5000;
	}
	
	void dec() {
		for (int i = 0; i < 6; i++) {
			if (a[i] > 0) {
				a[i]--;
				return;
			}
		}
	}

	void solve() throws IOException {
		for (int i = 0; i < 6; i++) {
			a[i] = readInt();
		}
		int price = readInt();
		int high = money() / price;
		dec();
		int low = money() / price;
		out.println(high - low);
		for (int i = low + 1; i < high; i++) {
			out.print(i + " ");
		}
		out.print(high);
	}

}
